﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MulThreadDelegate
{
    public partial class Form1 : Form
    {
        delegate string MyDel(string name, int id, out string unit);
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MyDel del = new MyDel(InsertUser);
            del += InsertDog;
            string unit = string.Empty;
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            //var restring = del.Invoke("天", 1, out unit);
            var restring = del("天", 1, out unit);
            Console.WriteLine(restring);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            AsyncCallback acb = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");


                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };


            MyDel del = new MyDel(InsertUser);
            //不能添加两个方法，只能有且只有一个
            //del += InsertDog;
            string unit = string.Empty;
            Console.WriteLine("主线程开始执行");
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            var asyncResult = del.BeginInvoke("地", 2, out unit, acb, "回掉状态");
            var restring = del.EndInvoke(out unit, asyncResult);
            Console.WriteLine("主线程结束执行");
            Console.WriteLine(restring);
        }







        string InsertUser(string userName, int id, out string unit)
        {
            unit = userName + id.ToString();
            Console.WriteLine($"User开始执行");
            Console.WriteLine($"User线程ID:{Thread.CurrentThread.ManagedThreadId}");
            return unit;
        }

        string InsertDog(string dogName, int id, out string unit)
        {
            unit = dogName + id.ToString();
            Console.WriteLine($"Dog开始执行");
            Console.WriteLine($"Dog线程ID:{Thread.CurrentThread.ManagedThreadId}");
            return unit;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            AsyncCallback acb = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                Thread.Sleep(5000);

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };


            MyDel del = new MyDel(InsertUser);
            //不能添加两个方法，只能有且只有一个
            //del += InsertDog;
            string unit = string.Empty;
            Console.WriteLine("主线程开始执行");
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            var asyncResult = del.BeginInvoke("地", 2, out unit, acb, "回掉状态");
            asyncResult.AsyncWaitHandle.WaitOne(3000);
            Console.WriteLine("主线程结束执行");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            AsyncCallback acbUser = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                Thread.Sleep(5000);

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };
            AsyncCallback acbDog = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                Thread.Sleep(5000);

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };


            MyDel delUser = new MyDel(InsertUser);
            MyDel delDog = new MyDel(InsertDog);
            string unit = string.Empty;
            Console.WriteLine("主线程开始执行");
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            var asyncResultUser = delUser.BeginInvoke("天", 2, out unit, acbUser, "天回掉状态");
            var asyncResultDog = delDog.BeginInvoke("地", 2, out unit, acbDog, "地回掉状态");

            WaitHandle.WaitAll(new WaitHandle[] {
                asyncResultUser.AsyncWaitHandle,
                asyncResultDog.AsyncWaitHandle
            });

            Console.WriteLine("主线程结束执行");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            AsyncCallback acbUser = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                Thread.Sleep(1000);

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };
            AsyncCallback acbDog = (t) =>
            {
                Console.WriteLine("异步回掉开始执行");
                Console.WriteLine($"异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                Thread.Sleep(5000);

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };


            MyDel delUser = new MyDel(InsertUser);
            MyDel delDog = new MyDel(InsertDog);
            string unit = string.Empty;
            Console.WriteLine("主线程开始执行");
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            var asyncResultUser = delUser.BeginInvoke("天", 2, out unit, acbUser, "天回掉状态");
            var asyncResultDog = delDog.BeginInvoke("地", 2, out unit, acbDog, "地回掉状态");

            WaitHandle.WaitAny(new WaitHandle[] {
                asyncResultUser.AsyncWaitHandle,
                asyncResultDog.AsyncWaitHandle
            });

            Console.WriteLine("主线程结束执行");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            AsyncCallback acbUser = (t) =>
            {
                Thread.Sleep(5000);
                Console.WriteLine("User异步回掉开始执行");
                Console.WriteLine($"User异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };
            AsyncCallback acbDog = (t) =>
            {
                Thread.Sleep(5000);
                Console.WriteLine("DOG异步回掉开始执行");
                Console.WriteLine($"DOG异步回掉线程ID:{Thread.CurrentThread.ManagedThreadId}");

                

                Console.WriteLine(t.AsyncState);
                Console.WriteLine(t.IsCompleted);
                Console.WriteLine(t.CompletedSynchronously);
            };


            MyDel delUser = new MyDel(InsertUser);
            MyDel delDog = new MyDel(InsertDog);
            string unit = string.Empty;
            Console.WriteLine("主线程开始执行");
            Console.WriteLine($"主线程ID:{Thread.CurrentThread.ManagedThreadId}");
            var asyncResultUser = delUser.BeginInvoke("天", 2, out unit, acbUser, "天回掉状态");
            var asyncResultDog = delDog.BeginInvoke("地", 2, out unit, acbDog, "地回掉状态");

            WaitHandle.SignalAndWait(
                asyncResultUser.AsyncWaitHandle,
                asyncResultDog.AsyncWaitHandle
            );

            Console.WriteLine("主线程结束执行");
        }
    }
}
